% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/coef_extractor.R
\name{coefficient_extractor.nbboot}
\alias{coefficient_extractor.nbboot}
\title{Bootstrap coefficient extractor}
\usage{
\method{coefficient_extractor}{nbboot}(object, ...)
}
\arguments{
\item{object}{A fitted nbboot model with bootstraps}

\item{...}{Not in use}
}
\value{
A tibble with coefficient value, one row per bootstrap
}
\description{
Bootstrap coefficient extractor
}
\examples{
data(genevzinb2)
model <- evzinb(y~x1+x2+x3,data=genevzinb2, n_bootstraps = 10, multicore = TRUE, ncores = 2)
zinb_comp <- compare_models(model)
coefficient_extractor(zinb_comp$nb)

}
